'use server';
import { NextResponse } from 'next/server';
import { GraphQLClient, gql } from 'graphql-request';

const endpoint = "http://localhost:3001/graphql";

export async function POST(request: Request) {
    const body = await request.json();
    const { limit, skip, sort, filters } = body;
    try {
        const client = new GraphQLClient(endpoint);
        const query = gql`
            query GetUserTypes($input: ListArguments!) {
                getUserTypes(input: $input) {
                    data {
                        _id
                        uuid
                        createdAt
                        updatedAt
                        expiryStarts
                        expiryEnds
                        type
                        token
                        typeToken
                        description
                        isProperty
                    }
                    totalCount
                }
            }
        `;
        const variables = { input: { limit, skip, sort, filters } };
        const data = await client.request(query, variables);
        return NextResponse.json({ data: data.getUserTypes.data, totalCount: data.getUserTypes.totalCount });
    } catch (err: any) {
        console.error(err);
        return NextResponse.json({ error: err.message }, { status: 500 });
    }
}
